unit FilProps;

{
1997 Apr 07  V1.1.2   Use ShellAPI function to move file to recycle bin
1998 May 05  V1.4.4   Add View button (ShellExecute)
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileProp, StdCtrls, ExtCtrls, ComCtrls;

type
  TfrmFileProperties1 = class(TfrmFileProperties)
    btnDelete: TButton;
    btnView: TButton;
    procedure btnDeleteClick(Sender: TObject);
    procedure btnViewClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmFileProperties1: TfrmFileProperties1;

implementation

uses ShellAPI;

{$R *.DFM}

procedure TfrmFileProperties1.FormShow(Sender: TObject);
begin
  inherited;
  btnView.Enabled := True;
end;


procedure TfrmFileProperties1.btnDeleteClick(Sender: TObject);
var
  shell_filename: string;
  SHFileOp: TSHFileOpStruct;
begin
  Inherited;
  // we return a result of either mrCancel if we didn't delete the file
  ModalResult := mrCancel;
  shell_filename := filename + #0#0;
  FillChar (SHFileOp, SizeOf (SHFileOp), 0);
  with SHFileOp do
    begin
    wFunc := FO_DELETE;
    pFrom := PChar (shell_filename);
    fFlags := FOF_ALLOWUNDO;
    end;
  SHFileOperation (SHFileOp);
  // we could check the eror code, simpler, see if the file has gone!
  // and if it's gone, return an mrYes
  if not FileExists (filename) then ModalResult := mrYes;
end;


procedure TfrmFileProperties1.btnViewClick(Sender: TObject);
var
  h: Longint;
  sys_dir: array [0..260] of char;
  viewer_name: string;
begin
  inherited;
  h := 0;
  if GetSystemDirectory (sys_dir, SizeOf (sys_dir)) <> 0 then
    begin
    viewer_name := sys_dir + '\viewers\QuikView.exe';
    if FileExists (viewer_name)
      then h := ShellExecute (0, nil, PChar (viewer_name), PChar (filename), nil, SW_SHOW)
      else h := ShellExecute (0, nil, PChar (filename), nil, nil, SW_SHOW);
    end;
  // check for the error code from launching the application,
  // if we failed disable the View button this time round
  btnView.Enabled := h > 32;
end;


end.

